<?php

# Flip 3 (Flatfile PHP Weblog)
# copyright 2002-2003, Adam Scheinberg
# http://flipsource.org
# http://www.sourceforge.net/projects/flipsource

# This is free software.  
# You may use this software however you wish, provided you leave 
# the above copyright notices intact. 

 //this page contains common Flip functions that may be used in multiple pages.
 
 //you can't get to this page directly.  don't modify next three lines
if(ereg("commonfxs.php", $PHP_SELF)) {
echo "<meta http-equiv=\"Refresh\" content=\"0; url=index.php\">";
exit; } 

ob_start();

 # this lengthy function was written by Jamie Burns of dynamicexpression.co.uk
 # reused with permission
 # portions have been added by Adam Scheinberg, adam@flipsource.org
 # it may NOT be reproduced without credit to the above author 
 
 function makeProperComment($comment_text_variable) { 
 
 # temporarily revert html entity quotes into normal ones (via percent sign)
 # added 26 march 2003
 $comment_text_variable = str_replace('%', '~*~@~', $comment_text_variable);
 $comment_text_variable = str_replace('&quot;', '%', $comment_text_variable);

 # make links from really long URLs
 # amended 10 april 2003
 $comment_text_variable = preg_replace(
'%((?:https?|ftp)://)([^\s\%\)\]\']{60})([^\s\%\)\]\']+?)([\.,]*?)(\s|\%|\)|
\]|\'|$)%',
  '<a href="$1$2$3~*~#~">$1$2~*~#~...</a>$4$5',
  $comment_text_variable
 );

 # make links from typical URLs
 # amended 10 april 2003
 $comment_text_variable = preg_replace(
  '%((?:https?|ftp)://)([^\s\%\)\]\']{1,60}?)([\.,]*?)(\s|\%|\)|\]|\'|$)%',
  '<a href="$1$2~*~#~">$1$2~*~#~</a>$3$4$5',
  $comment_text_variable
 );


 # move commas and full stops off the end any links
 # added 26 march 2003
 $comment_text_variable = preg_replace(
  '/(<a href="[^"]+)([,\.])~\*~#~(">[^<]+)[,\.]~\*~#~(<\/a>)/',
  '$1$3$4$2',
  $comment_text_variable
 );

 # remove comma/full stop markers with a space
 # added 26 march 2003
 $comment_text_variable = str_replace('~*~#~', '', $comment_text_variable);

 # if a user tried to embed an <A HREF=".."> tag, only show link, not the tag on the page
 # amended 15 april 2003
 $comment_text_variable = preg_replace(
  '/&lt;a [^<]*?href=.*?(<a href[^>]*>)([^<]*)(<\/a>).*?&gt;(.*?)/i',
  '$1$2$3 $4',
  $comment_text_variable
 );

 # if a user tried to embed an </A> tag, remove it
 # added 15 april 2003
 $comment_text_variable = preg_replace(
  '/&lt;\/a.*?&gt;/i',
  '',
  $comment_text_variable
 );


 # break really long words
 # amended 31 march 2003
 while (preg_match('/[^\s<>]{71}/', $comment_text_variable)) {
  $comment_text_variable = preg_replace(
   '/([^\s<>]{70})(\S+)/',
   '$1 ,~=,~= $2',
   $comment_text_variable
  );
 }

 # fix really long URLs we just messed up
 # we really should truncate after 250 chars or so ...
 # amended 26 march 2003
 while (preg_match('/(<a [^>]+?) ,~=,~= ([^>]+>)/', $comment_text_variable)) {
  $comment_text_variable = preg_replace(
   '/(<a [^>]+?) ,~=,~= ([^>]+>)/',
   '$1$2',
   $comment_text_variable
  );
 }

 # fix really long URL *ENDS* we just messed up ;o)
 # we really should truncate after 250 chars or so ...
 # added 31 march 2003
 while (preg_match('/(<[^>]*?) ,~=,~= ([^>]*?>)/', $comment_text_variable)) {
  $comment_text_variable = preg_replace(
   '/(<[^>]*?) ,~=,~= ([^>]*?>)/',
   '$1$2',
   $comment_text_variable
  );
 }

 # fix really long visible URL text that got messed up
 # truncating after 250 chars would be good here too.
 # added 26 march 2003
 while (preg_match('/(<a [^>]+>)([^<]*?) ,~=,~= ([^<]*)(<\/a[^>]*>)/',
$comment_text_variable)) {
  $comment_text_variable = preg_replace(
   '/(<a [^>]+>)([^<]*?) ,~=,~= ([^<]*)(<\/a[^>]*>)/',
   '$1$2$3$4',
   $comment_text_variable
  );
 }

 # convert temporary quotes back to html entities (via percent sign)
 # added 26 march 2003
 $comment_text_variable = str_replace('%', '&quot;', $comment_text_variable);
 $comment_text_variable = str_replace('~*~@~', '%', $comment_text_variable);

 # replace word break markers with a space
 $comment_text_variable = str_replace(' ,~=,~= ', ' ', $comment_text_variable);

return $comment_text_variable;
}

 # this function written by A.S. 
function emailMask($address, $name) { 
	$possible_ats = array(" at ", " [at] ", "/", "-at-", " @@ ", "@@@", "(at) ", " \@\ ","~at~", "_at_"," <at> ", "@at@", "]at[", "&");
	$possible_dots= array(" dot ", " [dot] ", "/", "-dot-", " period ", "&middot;"," (dot) "," \.\ ","...","-","~dot~","[.]","_dot_", " <dot> ", "|.|", ".skipthispart.", ".nospam.", "]dot[");
	srand((double)microtime()*1000000); 
	$at = rand(0,count($possible_ats)-1);
	$dot = rand(0,count($possible_dots)-1);  
    if(preg_match("/(([\w\.]+))(@)([\w\.]+)\b/i",$address)) {  
        $mask = str_replace(".",$possible_dots[$dot], $address); 
        $mask = str_replace("@",$possible_ats[$at], $mask); 
        $mask = "<a href=\"mailto:$mask\">$name</a>"; 
		return $mask; } 
	elseif (preg_match("/(http|ftp|https|ftps)(:\/\/)(.*?)([,\.\)!\?\]:;]*(\s|$))/",$address)) { 
		$mask = "<a href=\"$address\">" . $name . "</a>"; 
		return $mask; } 
	else { 
        $mask = $address;  
        $mask = "<a href=\"mailto:$mask\">$name</a>"; 
		return $mask; }  
    } 

// UMS functions
# based on functions written by by Justin Hagstrom, http://justin.yi.org:99
# except where noted, by A.S., flipsource.org
/*  $usrnfo[0]=md5-encrypted password, $usrnfo[1]=username, $usrnfo[2]=domain, $usrnfo[3]=mailbox, $usrnfo[4]=rights */

if(!isset($userfile)) { $userfile = "./users.txt"; }

# A.S., flipsource.org
function getInfoByEmail($email) { 
	global $userfile;	
	$users = file($userfile) or die("Could not open user database.");
	for($u=0;$u<=sizeof($users);$u++) {
		$usrnfo = explode("][", $users[$u]); 
		$aor = $usrnfo[3] . "@" . $usrnfo[2];	
		if (trim($aor) == trim($email)) { $output = trim($users[$u]); }  
	}
	return $output;
}

function getInfoByUser($username) { 
	global $userfile;	
	$users = file($userfile) or die("Could not open user database.");
	for($u=0;$u<=sizeof($users);$u++) {
		$usrnfo = explode("][", $users[$u]); 
		$uname = $usrnfo[1];	
		if (trim($uname) == trim($username)) { $output = trim($users[$u]); }  
	}
	if($output) { return $output; } else { return 0; }
}

function checkLogin($user,$pass)
{
	global $userfile;	
	$users = file($userfile) or die("Could not open user database.");
	foreach($users as $userInfo) {
		$usrnfo = explode("][", $userInfo); 	
		if ( (trim($usrnfo[1])==$user) && ($usrnfo[0] == $pass) )
			return 1; }
	return 0;
}

function isAdmin($user)
{
	global $userfile;
	$users = file($userfile) or die("Could not open user database.");
	foreach($users as $userInfo)
	{
		$usrnfo = explode("][", $userInfo);
		if($user == trim($usrnfo[1])) { return $usrnfo[4]; }
	}
}

function isUsername($user)
{
	global $userfile;
	$users = file($userfile) or die("Could not open user database.");
	foreach($users as $userInfo)
	{
		$usrnfo = explode("][", $userInfo); 	
		if ( trim($usrnfo[1]) == $user )
			return 1; 
	}
	return 0;
}

function explainRights($r, $prefix) {
	if(!$prefix) { $prefix = ""; } 
	$rights = $prefix . "You may leave comments on all articles.<br />\n";
	$rights .= $prefix . "You can edit your own account information.<br />\n";
	if($r > 0) {
		  $rights .= $prefix . "You can add articles to all categories.<br />\n";
		  $rights .= $prefix . "You can moderate comment posts.<br />\n"; }
	if($r == "1") { $rights .= $prefix . "You may edit and delete your own articles.<br />\n"; }
	if($r > 1) {
		  $rights .= $prefix . "You can edit all posts, regardless of owner.<br />\n";
		  $rights .= $prefix . "You can change any user's account information.<br />";
		  $rights .= $prefix . "You may login as any user through the admin console.<br />";
	}
	if($r > 2) { 
		  $rights .= $prefix . "You can edit all accounts, including admins.<br />\n";
		  $rights .= $prefix . "You can make changes to the look and feel of the site.<br />";
		  //3.1, perhaps...
		  //$rights .= $prefix . "You can execute <a href=\"http://flipsource.org/ninja/\">NINJA</a> to change site-wide configuration options.<br />";  
	}
	echo $rights;
}

# A.S., flipsource.org
function isLoggedIn() { 
	if(($_COOKIE['un']) && ($_COOKIE['pw'])) { 
		if(checkLogin($_COOKIE['un'], $_COOKIE['pw'])) {
			return 1; } 
			}
}	

# A.S., flipsource.org
function makeRandomPass() {
	$validchars = array("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","0","1","2","3","4","5","6","7","8","9","!","@","%","^","&","-","+");
	srand((float) microtime() * 10000000);
	$len = mt_rand(6,14); 
	$rand_keys = array_rand($validchars, $len);
	for($k=0;$k<$len;$k++) { $passr[] = $validchars[$rand_keys[$k]]; } 
	shuffle($passr);
	foreach($passr as $letter) { $pass .= trim($letter); } 
	return $pass; 
	}

# A.S., flipsource.org
function chkUsername($un) {
	if(strstr($un,"][")) { $errors .= "You cannot use the characters \"][\" in succession in your username.<br />\n"; } 
	if(strstr($un,"|")) { $errors .= "You cannot use the \"|\" character in your username.<br />\n"; } 
	if(strstr($un,'"')) { $errors .= "You cannot use double quotes in your username.<br />\n"; } 
	if (!preg_match("/^[_a-zA-Z0-9!@\$%\^\s&]{3,}$/", $un)) {$errors .= "You have illegal characters in your username.<br />"; } 
	if ($errors) { return 0; } else { return 1; }
	}
?>