<?php

# Flip 3 (Flatfile PHP Weblog)
# copyright 2002-2003, Adam Scheinberg
# http://flipsource.org
# http://www.sourceforge.net/projects/flipsource

# This is free software.  
# You may use this software however you wish, provided you leave 
# the above copyright notices intact. 

# options.inc.php

// edit all variables between the stars - do NOT use double quotes (").  
// Make sure you escape quotes and dollar signs like this: \' \" \$ 
//=========================================================================

#> BASIC OPTIONS
//URL of your site, with terminating slash
$siteurl 		= "http://example.com/"; 
//public name of your weblog
$logsitename 	= "My Weblog";
//if you want a tiny caption, specify here
$caption 		= "[based on Flip]";   
// a comment to display in tiny title bar (only if you DON'T have a menu)
$wittycomment 	= "the world's easiest weblog";  

#> ALIGNMENT OPTIONS
//do you want to display statistics about your site? 1 for true, 0 for false 
$showstats 		= "1"; 
//logo alignment - 1 for left, 2 for center, 3 for right
$logoalign 		= "1"; 
//table width in pixels or percentage, leave blank for default of 640
$tablewidth 	= "95%";    
//width of sidebar, in percent - NO PERCENT SYMBOL!
$sidebarwidth 	= "15";		
//name of your default theme, users can change this for themselves
//themes are in themes folder
$defaulttheme	= "Three"; 	


#> CONFIG OPTIONS
//number of articles to display on front page, leave blank for default of 15
$dispnum 		= "15";
//e-mail address of the person who gets notifications of adds, mods, and deletions
$logadmin 		= "webmaster@yourdomain.com";  
//display name of the person who runs the site
$logownername	= "Webmaster";	
//notify admin of adds, edits, deletions / set to 1 for yes or 0 for no
$notifyadmin 	= "1";		
//thank user for submission via e-mail? / set to 1 for yes or 0 for no
$notifyposter 	= "1";	
//allow non-registered users full functionality? Use YES or NO	
$allow_anonymous = "yes";	
//display newest comments first?
$nfc			= FALSE; 

#> ADDITIONAL CONFIG OPTIONS
//message users see if they can't edit
$errormessage 	= "You do not have enough rights to complete this operation."; 	
//"tip" displayed on the admin page
$adminmessage 	= "Please make sure that you close your HTML tags.";
//name of poster if no name is submitted (i.e. "No Name" or "Anonymous Coward")
$anonymous 		= "Anonymous Poster";	
//possible categories (should be an image in the img directory to correspond) 
$category 		= array("weblog", "people", "news", "important", "computers", "pleasure", "good_stuff"); 
//extension of your image files, no dot!
$catext 		= "png";  
//prefix on various menus
$navprefix		= " &middot; "; 

#> INCLUDED FILE OPTIONS
// path to non-modifiable include files 
//don't forget the trailing slash - leave this as is unless you know otherwise
$incpath		= "./inc/"; 
// path to edittable include files 
//don't forget the trailing slash - leave this as is unless you know otherwise
$varpath		= "./var/"; 
//file where articles will be stored, must be chmodded to 777	
$newsfile 		= $varpath."flipfeed.txt";  
// if you want menu bar across the top, specify the file here					
$menubar		= "";
//page header - be careful if you edit this! 
$header			= $incpath."head.inc.php";	
//if you want a footer added to each page, specify it here
$footer			= $incpath."footer.inc.php";	
//built in lefthand navbar
$leftnav		= $incpath."leftnav.inc.php";	
//built in righthand navbar
$rightnav		= $incpath."rightnav.inc.php";	
//links file
$linkfile		= $varpath."links.txt"; 
//user info file
$userfile		= $varpath."users.txt";  
//hot list file
$hotlist		= $varpath."hotlist.txt"; 


#> TIME AND DATE OPTIONS
//time zone you are in
$timezone 		= "EST";	
//how you'd like date and time displayed. 
//see http://php.net/date for valid options
$dateformat 	= "m/d/Y, H:i"; 

//==============================================================================								
/* DO NOT EDIT BELOW THIS LINE */

//you can't get to this page directly. 
if(ereg(".inc.php", $_SERVER['PHP_SELF'])) {
Header("Location: $siteurl");
exit; }
$timezones = array(
		   "IDL" => -12,
		   "BT" => -11,
		   "AHST" => -10,
		   "YST" => -9,
		   "PST" => -8,
		   "MST" => -7,
		   "CST" => -6,
		   "EST" => -5,
		   "AST" => -4,
		   "BST" => -3,
		   "AT" => -2,
		   "WAT" => -1,
		   "GMT" => 0,
		   "CET" => 1,
		   "EET" => 2,
		   "BT" => 3,
		   "ZP4" => 4,
		   "ZP5" => 5,
		   "ZP6" => 6,
		   "SST" => 7,
		   "CCT" => 8,
		   "JST" => 9,
		   "GST" => 10,
		   "EADT" => 11,
		   "NZT" => 12,
		   "NZDT" => 12);
    $ddday         = gmdate("d");
    $ddmonth       = gmdate("m");
    $ddhour        = gmdate("g");
    $ddyear        = gmdate("Y");
    $ddminutes     = gmdate("i");
    $ddseconds     = gmdate("s");
    $ddhour        = gmdate("H") + $timezones[strtoupper($timezone)];
    $ddtime        = mktime($ddhour, $ddminutes, $ddseconds, $ddmonth, $ddday, $ddyear);
    if (date('I', $ddtime)) { $ddtime += 3600; }
$postdate = date($dateformat, $ddtime); 
$phpv = phpversion(); 
if($phpv >= 4.2) { $self = $_SERVER['PHP_SELF']; } else { $self = $PHP_SELF; } 
$newshome = "index.php";
$allnews  = "current.php"; 
$details = "viewcomments.php"; //getting ready for Flip 3.1
$allow_anonymous = strtolower($allow_anonymous);
sort($category);  
$mainbarwidth = (100 - $sidebarwidth);   
$is_slash = substr($siteurl, -1); // returns last char 
if($is_slash != "/") { $siteurl .= "/"; } 
$navigationbar = $leftnav; //temp legacy var
$homename = stripslashes($logsitename); //temp legacy var 
if (isset($_COOKIE['fliptheme'])) { $themename = $_COOKIE['fliptheme']; 
} else { $themename = $defaulttheme; }
$stylesheet = "./themes/" . $themename . "/stylesheet.css";
if(!file_exists($stylesheet)) { $stylesheet = "./themes/default/stylesheet.css"; }
$subtheme = "./themes/" . $themename . "/subtheme.php";
if(!file_exists($subtheme)) { $subtheme = "./themes/default/subtheme.php"; }
include($subtheme); 

//just in case anything is blank...
if (empty($dispnum)) { $dispnum = "15"; }
if (empty($sidebarwidth)) { $sidebarwidth = "15"; }
if (empty($themename)) { $themename = "default"; }
if (empty($tablewidth)) { $tablewidth = "90%"; }
$Flip_version = "3.0";
?>
